#include <Windows.h>
#include <Shlwapi.h>
#include "Util.h"
#include "TsAnalyzer.h"
#define BONSDK_IMPLEMENT
#include "IBonDriver3.h"
#include "BonDriverWrapper.h"

#define WRAPPED_DLL_SUFFIX  TEXT("_TotWrapped.dl_")

HINSTANCE g_hModule;
static IBonDriver *g_pBonThis;

/////////////////////////////////////////////////////////////////////////////
// DLLGg[
/////////////////////////////////////////////////////////////////////////////

BOOL APIENTRY DllMain(HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
    switch (ul_reason_for_call) {
    case DLL_PROCESS_ATTACH:
        g_hModule = hModule;
        break;
    case DLL_PROCESS_DETACH:
        // ̏ꍇ̓CX^X
        if (g_pBonThis) {
            DEBUG_OUT(APP_NAME TEXT("::DllMain(): Driver Is Not Released!\n"));
            // TODO: FreeLibrary()ĂԂ̂ŏ肭ȂȂ
            g_pBonThis->Release();
        }
        break;
    }
    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// BonDrivert@Ng[API
/////////////////////////////////////////////////////////////////////////////

extern "C" typedef IBonDriver * (FCREATEBONDRIVER)(void);

extern "C" BONAPI IBonDriver * CreateBonDriver(void)
{
    // ̏ꍇ̓|C^Ԃ
    if (g_pBonThis) return g_pBonThis;

    // bvDLLĂяo
    HINSTANCE hModuleWrapped = NULL;
    TCHAR szName[MAX_PATH], szModulePath[MAX_PATH], szPath[MAX_PATH];
    DWORD rv = ::GetModuleFileName(g_hModule, szModulePath, _countof(szModulePath));
    if (rv && rv < _countof(szModulePath) - 1) {
        // Ol[
        rv = ::GetLongPathName(szModulePath, szPath, _countof(szPath));
        if (rv && rv < _countof(szPath)) {
            ::PathRemoveExtension(szPath);
            if (::lstrlen(szPath) <= _countof(szPath) - _countof(WRAPPED_DLL_SUFFIX)) {
                ::lstrcpy(szName, ::PathFindFileName(szPath));
                ::lstrcat(szPath, WRAPPED_DLL_SUFFIX);
                hModuleWrapped = ::LoadLibrary(szPath);
            }
        }
    }
    if (!hModuleWrapped) {
        DEBUG_OUT(APP_NAME TEXT("::CreateBonDriver(): LoadLibrary Failed\n"));
        goto ERROR_EXIT;
    }

    // hCo|C^擾
    FCREATEBONDRIVER *pfCreateBonDriver =
        reinterpret_cast<FCREATEBONDRIVER*>(::GetProcAddress(hModuleWrapped, "CreateBonDriver"));
    if (!pfCreateBonDriver) {
        DEBUG_OUT(APP_NAME TEXT("::CreateBonDriver(): GetProcAddress Failed\n"));
        goto ERROR_EXIT;
    }
    // bvCX^X
    DEBUG_OUT(APP_NAME TEXT("::CreateBonDriver(): "));
    IBonDriver *pBonWrapped = pfCreateBonDriver();
    if (!pBonWrapped) {
        DEBUG_OUT(TEXT("Failed\n"));
        goto ERROR_EXIT;
    }
    // bv(g_pBonThis==NULLɂȂ)
    IBonDriver2 *pBonWrapped2 = dynamic_cast<IBonDriver2*>(pBonWrapped);
    if (!pBonWrapped2) {
        DEBUG_OUT(TEXT("return IBonDriver\n"));
        return new CBonDriverWrapper(pBonWrapped, hModuleWrapped, szName, &g_pBonThis);
    }
    IBonDriver3 *pBonWrapped3 = dynamic_cast<IBonDriver3*>(pBonWrapped2);
    if (!pBonWrapped3) {
        DEBUG_OUT(TEXT("return IBonDriver2\n"));
        return new CBonDriver2Wrapper(pBonWrapped2, hModuleWrapped, szName, &g_pBonThis);
    }
    DEBUG_OUT(TEXT("return IBonDriver3\n"));
    return new CBonDriver3Wrapper(pBonWrapped3, hModuleWrapped, szName, &g_pBonThis);

ERROR_EXIT:
    if (hModuleWrapped) ::FreeLibrary(hModuleWrapped);
    return NULL;
}
