#ifndef INCLUDE_TS_ANALYZER_H
#define INCLUDE_TS_ANALYZER_H

#if 1 // BonDriver_TotWrap萔`
#define TOTWRAP_CLASSNAME   TEXT("TOTWRAP-A55C8670-B588-44DC-A89D-59638204C2BE")
#define TOTWRAP_BROADCAST   TOTWRAP_CLASSNAME
#define TOTWRAP_CAPTION_MAX 64
#endif

class CTsAnalyzer
{
public:
    CTsAnalyzer(LPCTSTR caption);
    ~CTsAnalyzer();
    void OnGetTsStream(const BYTE *pDst, DWORD dwSize, DWORD dwRemain);
private:
    void ProcessPacket(const BYTE *pData);
    void OnTotUpdated();
    static DWORD WINAPI WndThread(LPVOID pParam);
    static LRESULT CALLBACK WndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    static const int BUF_SIZE = 4096;
    BYTE m_buf[BUF_SIZE], m_carry[320+1];
    int m_bufCount, m_carryCount, m_syncUnit;
    bool m_fSynced;

    CCriticalLock m_totLock;
    __int64 m_tickTot;
    SYSTEMTIME m_stTot;
    FILETIME m_ftTot;
    UINT m_totwMsg;
    HWND m_hwnd;
    HANDLE m_hThread, m_hThreadEvent;
    TCHAR m_caption[TOTWRAP_CAPTION_MAX];
    bool m_fNeedToUpdate, m_fInnerSetText;
};

#endif // INCLUDE_TS_ANALYZER_H
