// TOTŎv킹Ƃ
// ŏIXV: 2012-03-08
// : 796fc11fa89e651a696eaef04fc4ca2c
#include <Windows.h>
#include <Shlwapi.h>
#include <Psapi.h>
#include <tchar.h>
#include <vector>
#include <map>
#include "resource.h"

#if 1 // BonDriver_TotWrap萔`
#define TOTWRAP_CLASSNAME   TEXT("TOTWRAP-A55C8670-B588-44DC-A89D-59638204C2BE")
#define TOTWRAP_BROADCAST   TOTWRAP_CLASSNAME
#define TOTWRAP_CAPTION_MAX 64
#endif

void UnixTimeToFileTime(int unixTime, FILETIME *pTime)
{
    __int64 ll = ((__int64)unixTime * 10000000) + 116444736000000000;
    pTime->dwHighDateTime = (DWORD)(ll >> 32);
    pTime->dwLowDateTime = (DWORD)ll;
}

// EBhE쐬vZX̎st@C擾
DWORD GetWindowProcessPathName(HWND hWnd, TCHAR *lpszPath, DWORD cchBuffer)
{
    DWORD dwRet = 0;
    DWORD dwProcessId = 0;
    if (::GetWindowThreadProcessId(hWnd, &dwProcessId)) {
        HANDLE hProcess = ::OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwProcessId);
        if (hProcess) {
            HMODULE hModule;
            DWORD cbNeeded;
            if (::EnumProcessModules(hProcess, &hModule, sizeof(hModule), &cbNeeded) && cbNeeded >= sizeof(hModule)) {
                TCHAR szModulePath[1024];
                DWORD dwLen = ::GetModuleFileNameEx(hProcess, hModule, szModulePath, _countof(szModulePath));
                if (dwLen && dwLen < _countof(szModulePath) - 1) {
                    dwLen = ::GetLongPathName(szModulePath, lpszPath, cchBuffer);
                    if (dwLen && dwLen < cchBuffer) dwRet = dwLen;
                }
            }
            ::CloseHandle(hProcess);
        }
    }
    return dwRet;
}

#if 1 // From: TVTest_0.7.23_Src/Util.cpp
FILETIME &operator+=(FILETIME &ft,LONGLONG Offset)
{
	ULARGE_INTEGER Result;

	Result.LowPart=ft.dwLowDateTime;
	Result.HighPart=ft.dwHighDateTime;
	Result.QuadPart+=Offset;
	ft.dwLowDateTime=Result.LowPart;
	ft.dwHighDateTime=Result.HighPart;
	return ft;
}

LONGLONG operator-(const FILETIME &ft1,const FILETIME &ft2)
{
	LARGE_INTEGER Time1,Time2;

	Time1.LowPart=ft1.dwLowDateTime;
	Time1.HighPart=ft1.dwHighDateTime;
	Time2.LowPart=ft2.dwLowDateTime;
	Time2.HighPart=ft2.dwHighDateTime;
	return Time1.QuadPart-Time2.QuadPart;
}

void GetLocalTimeAsFileTime(FILETIME *pTime)
{
	SYSTEMTIME st;

	GetLocalTime(&st);
	SystemTimeToFileTime(&st,pTime);
}
#endif

struct NODE_INFO {
    DWORD tick;
    FILETIME ft;
    bool fTrusted;
    TCHAR caption[TOTWRAP_CAPTION_MAX];
    TCHAR path[1024];
};

struct TRUSTED_INFO {
    TCHAR path[1024];
};

static void UpdateNodeMap(std::map<UINT_PTR, NODE_INFO> &nodeMap, const std::vector<TRUSTED_INFO> &trusteds, LPCTSTR exclude)
{
    // fXNgbvTotWrapEBhEă}bvɒǉorXV
    HWND hwndNode = NULL;
    while ((hwndNode = ::FindWindowEx(HWND_MESSAGE, hwndNode, TOTWRAP_CLASSNAME, NULL)) != NULL) {
        TCHAR title[128 + TOTWRAP_CAPTION_MAX];
        DWORD_PTR dwLen;
        if (::SendMessageTimeout(hwndNode, WM_GETTEXT, _countof(title), (LPARAM)title, SMTO_NORMAL, 1000, &dwLen) &&
            dwLen >= 12 && !::StrCmpN(title, TEXT("TOTWRAP "), 8))
        {
            int insLen = ::StrToInt(title+9);
            if (title[8] == TEXT('N')) {
                // m[h폜
                nodeMap.erase((UINT_PTR)hwndNode);
            }
            else if (title[8] == TEXT('Y') && insLen >= 33 && (int)dwLen >= 12+insLen) {
                LONGLONG llftLow, llftHigh, llTick;
                if (::StrToInt64Ex(title+12, STIF_SUPPORT_HEX, &llTick) &&
                    ::StrToInt64Ex(title+23, STIF_SUPPORT_HEX, &llftLow) &&
                    ::StrToInt64Ex(title+34, STIF_SUPPORT_HEX, &llftHigh))
                {
                    std::map<UINT_PTR, NODE_INFO>::iterator it = nodeMap.find((UINT_PTR)hwndNode);
                    if (it == nodeMap.end()) {
                        // m[hǉ
                        NODE_INFO nodeInfo;
                        nodeInfo.tick = (DWORD)llTick;
                        nodeInfo.ft.dwLowDateTime = (DWORD)llftLow;
                        nodeInfo.ft.dwHighDateTime = (DWORD)llftHigh;
                        ::lstrcpyn(nodeInfo.caption, title+12+insLen, _countof(nodeInfo.caption));
                        // st@CpX擾
                        if (!GetWindowProcessPathName(hwndNode, nodeInfo.path, _countof(nodeInfo.path))) {
                            ::lstrcpy(nodeInfo.path, TEXT("<Unknown>"));
                        }
                        // Mst@Cǂ
                        // łɃLvVp^[ŃtB^
                        nodeInfo.fTrusted = false;
                        TCHAR pattern[TOTWRAP_CAPTION_MAX + 2];
                        ::wsprintf(pattern, TEXT(":%s:"), nodeInfo.caption);
                        if (!::StrStrI(exclude, pattern)) {
                            std::vector<TRUSTED_INFO>::const_iterator ci = trusteds.begin();
                            for (; ci != trusteds.end(); ++ci) {
                                if (!::lstrcmpi(ci->path, nodeInfo.path)) {
                                    nodeInfo.fTrusted = true;
                                    break;
                                }
                            }
                        }
                        nodeMap[(UINT_PTR)hwndNode] = nodeInfo;
                    }
                    else if (it->second.tick != (DWORD)llTick) {
                        // m[hXV
                        it->second.tick = (DWORD)llTick;
                        it->second.ft.dwLowDateTime = (DWORD)llftLow;
                        it->second.ft.dwHighDateTime = (DWORD)llftHigh;
                    }
                }
            }
        }
    }

    // łm[h}bv폜
    std::map<UINT_PTR, NODE_INFO>::iterator it = nodeMap.upper_bound(0);
    while (it != nodeMap.end()) {
        if (!::IsWindow((HWND)it->first)) nodeMap.erase(it++);
        else ++it;
    }
}

static void AdjustSystemTime(bool *pfAdjusting, const std::map<UINT_PTR, NODE_INFO> &nodeMap, int totDelay)
{
    // ݎ擾
    DWORD tickNow = ::GetTickCount();
    FILETIME ftNow;
    GetLocalTimeAsFileTime(&ftNow);

    // TOTƌݎƂ̍̕ϒl(~b)vZ
    std::map<UINT_PTR, NODE_INFO>::const_iterator it = nodeMap.begin();
    int num = 0;
    LONGLONG llTotAvgDiff = 0;
    for (; it != nodeMap.end(); ++it) {
        DWORD tickDiff = tickNow - it->second.tick;
        // 100bȏÂ͎gȂ
        if (tickDiff < 100000 && it->second.fTrusted) {
            llTotAvgDiff += (it->second.ft - ftNow) / 10000 + tickDiff + totDelay;
            ++num;
        }
    }
    if (num > 0) llTotAvgDiff /= num;

    // ߂肵ȂxɎ␳
    if (*pfAdjusting && -100 < llTotAvgDiff && llTotAvgDiff < 100) {
        // ␳OFF
        if (::SetSystemTimeAdjustment(0, TRUE)) {
            *pfAdjusting = false;
        }
    }
    else if (*pfAdjusting || (llTotAvgDiff < -1000 || 1000 < llTotAvgDiff)) {
        // ␳ON
        DWORD timeAdj, timeInc;
        BOOL timeAdjDisabled;
        if (::GetSystemTimeAdjustment(&timeAdj, &timeInc, &timeAdjDisabled) &&
            ::SetSystemTimeAdjustment(llTotAvgDiff < 0 ? timeInc/5 : timeInc*2, FALSE))
        {
            *pfAdjusting = true;
        }
    }
}

#define APP_NAME        TEXT("TotWatch")
#define WM_UPDATE_LIST  (WM_APP + 0)
#define WM_MYTRAY       (WM_APP + 1)
#define WM_SHOW_MYTRAY  (WM_APP + 2)

static const int ID_MYTRAY = 1;
static const int TIMER_ID_UPDATE = 1;
static const int TIMER_ID_ADJUST = 2;
static int g_updateInterval, g_setTimeTotDelay, g_msgCount;
static bool g_fTopMost, g_fMinimize, g_fMinToTray, g_fSetTime, g_fAdjusting;
static std::map<UINT_PTR, NODE_INFO> g_nodeMap;
static std::vector<TRUSTED_INFO> g_trusteds;
static TCHAR g_exclude[4096];
static UINT g_totwMsg;
static NOTIFYICONDATA g_nid;

static INT_PTR CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg) {
    case WM_INITDIALOG:
        {
            g_totwMsg = ::RegisterWindowMessage(TOTWRAP_BROADCAST);
            ::SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)::LoadIcon(
                          (HINSTANCE)::GetWindowLongPtr(hDlg, GWLP_HINSTANCE), (LPCTSTR)IDI_ICON));
            ::SetTimer(hDlg, TIMER_ID_UPDATE, g_updateInterval, NULL);
            if (g_fSetTime) {
                ::SetTimer(hDlg, TIMER_ID_ADJUST, 5000, NULL);
                ::SetWindowText(hDlg, APP_NAME TEXT(" (v킹[h)"));
            }
            RECT rc;
            if (::GetClientRect(hDlg, &rc)) {
                ::SendMessage(hDlg, WM_SIZE, SIZE_RESTORED, MAKELPARAM(rc.right, rc.bottom));
            }
            if (g_fTopMost) {
                ::SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
            }
            if (g_fMinimize) {
                ::ShowWindow(hDlg, SW_MINIMIZE);
            }
        }
        return TRUE;
    case WM_DESTROY:
        if (g_fAdjusting) {
            ::SetSystemTimeAdjustment(0, TRUE);
        }
        if (g_nid.cbSize) {
            ::Shell_NotifyIcon(NIM_DELETE, &g_nid);
        }
        break;
    case WM_COMMAND:
        if (LOWORD(wParam) == IDCANCEL) {
            ::EndDialog(hDlg, LOWORD(wParam));
        }
        break;
    case WM_SIZE:
        ::MoveWindow(::GetDlgItem(hDlg, IDC_LIST), 10, 10, LOWORD(lParam)-20, HIWORD(lParam)-20, TRUE);
        if (wParam == SIZE_MINIMIZED && g_fMinToTray) {
            // ŏŋNꍇ̂PostMessage()
            ::PostMessage(hDlg, WM_SHOW_MYTRAY, 1, 0);
        }
        break;
    case WM_MYTRAY:
        if (wParam == ID_MYTRAY && lParam == WM_LBUTTONUP) {
            ::SendMessage(hDlg, WM_SHOW_MYTRAY, 0, 0);
            return TRUE;
        }
        break;
    case WM_SHOW_MYTRAY:
        if (wParam && !g_nid.cbSize) {
            // ^XNgCɊi[
            g_nid.cbSize = sizeof(NOTIFYICONDATA);
            g_nid.hWnd = hDlg;
            g_nid.uID = ID_MYTRAY;
            g_nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
            g_nid.uCallbackMessage = WM_MYTRAY;
            g_nid.hIcon = (HICON)::SendMessage(hDlg, WM_GETICON, ICON_SMALL, 0);
            ::lstrcpyn(g_nid.szTip, APP_NAME, _countof(g_nid.szTip));
            if (!::Shell_NotifyIcon(NIM_ADD, &g_nid)) g_nid.cbSize = 0;
            else ::ShowWindow(hDlg, SW_HIDE);
        }
        else if (!wParam && g_nid.cbSize) {
            // ^XNgC畜
            ::Shell_NotifyIcon(NIM_DELETE, &g_nid);
            g_nid.cbSize = 0;
            ::ShowWindow(hDlg, SW_SHOW);
            ::ShowWindow(hDlg, SW_RESTORE);
        }
        return TRUE;
    case WM_TIMER:
        if (wParam == TIMER_ID_UPDATE) {
            UpdateNodeMap(g_nodeMap, g_trusteds, g_exclude);
            if (!::IsIconic(hDlg) && IsWindowVisible(hDlg)) {
                ::PostMessage(hDlg, WM_UPDATE_LIST, 0, 0);
            }
            return TRUE;
        }
        else if (wParam == TIMER_ID_ADJUST) {
            bool fLastAdjusting = g_fAdjusting;
            AdjustSystemTime(&g_fAdjusting, g_nodeMap, g_setTimeTotDelay);
            if (fLastAdjusting != g_fAdjusting) {
                // x̂ߎ␳̓C^[o
                ::SetTimer(hDlg, TIMER_ID_ADJUST, g_fAdjusting ? 200 : 5000, NULL);
                ::SetWindowText(hDlg, g_fAdjusting ? APP_NAME TEXT(" (v킹)") : APP_NAME TEXT(" (v킹[h)"));
            }
            return TRUE;
        }
        break;
    case WM_UPDATE_LIST:
        {
            // Xg{bNXNA
            HWND hList = ::GetDlgItem(hDlg, IDC_LIST);
            LRESULT curSel = ::SendMessage(hList, LB_GETCURSEL, 0, 0);
            ::SendMessage(hList, LB_RESETCONTENT, 0, 0);

            // ݎ擾
            DWORD tickNow = ::GetTickCount();
            FILETIME ftNow;
            GetLocalTimeAsFileTime(&ftNow);

            // Xg{bNXXV
            std::map<UINT_PTR, NODE_INFO>::const_iterator it = g_nodeMap.begin();
            for (; it != g_nodeMap.end(); ++it) {
                DWORD tickDiff = tickNow - it->second.tick;
                FILETIME ftTot = it->second.ft;
                ftTot += (LONGLONG)tickDiff * 10000;
                LONGLONG llTotDiff = (ftTot - ftNow) / 10000;
                SYSTEMTIME st;
                if (!::FileTimeToSystemTime(&ftTot, &st)) ::memset(&st, 0, sizeof(st));
                int totDiff = (int)min(max(llTotDiff, -99999), 99999);

                TCHAR text[512];
                ::wsprintf(text, TEXT("%08x %5u %04d-%02d-%02dT%02d:%02d:%02d %c%-5d %c%s %.260s\n"),
                           (DWORD)it->first, min(tickDiff, 99999),
                           st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond,
                           totDiff<0 ? TEXT('-') : TEXT('+'),
                           totDiff<0 ? -totDiff : totDiff,
                           it->second.fTrusted ? TEXT('*') : TEXT(' '),
                           it->second.caption, it->second.path);
                ::SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)text);
            }
            ::SendMessage(hList, LB_SETCURSEL, curSel, 0);
        }
        return TRUE;
    default:
        if (g_totwMsg && uMsg == g_totwMsg) {
            // XVm点u[hLXgbZ[W󂯎
            NODE_INFO nodeInfo;
            nodeInfo.tick = ::GetTickCount();
            UnixTimeToFileTime((int)lParam, &nodeInfo.ft);
            nodeInfo.fTrusted = false;
            ::wsprintf(nodeInfo.caption, TEXT("<Broadcast%d>"), g_msgCount++);
            ::lstrcpy(nodeInfo.path, TEXT("<Unknown>"));
            g_nodeMap[0] = nodeInfo;
            // xZLeB߂ȂȂ炱̏񂾂ł
            return TRUE;
        }
        break;
    }
    return FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
    TCHAR path[MAX_PATH], iniPath[MAX_PATH];
    if (::GetModuleFileName(::GetModuleHandle(NULL), path, _countof(path)) &&
        ::GetLongPathName(path, iniPath, _countof(iniPath)) &&
        ::PathRenameExtension(iniPath, TEXT(".ini")))
    {
        g_updateInterval = ::GetPrivateProfileInt(APP_NAME, TEXT("UpdateMsec"), 500, iniPath);
        g_fTopMost = ::GetPrivateProfileInt(APP_NAME, TEXT("TopMost"), 0, iniPath) != 0;
        g_fMinimize = ::GetPrivateProfileInt(APP_NAME, TEXT("Minimize"), 0, iniPath) != 0;
        g_fMinToTray = ::GetPrivateProfileInt(APP_NAME, TEXT("MinToTray"), 0, iniPath) != 0;
        g_fSetTime = ::GetPrivateProfileInt(APP_NAME, TEXT("SetTime"), 0, iniPath) != 0;
        g_setTimeTotDelay = ::GetPrivateProfileInt(APP_NAME, TEXT("TotDelayMsec"), 0, iniPath);
        ::GetPrivateProfileString(APP_NAME, TEXT("Exclude"), TEXT(""), g_exclude, _countof(g_exclude), iniPath);

        // Mst@C̃Xg쐬
        for (int i = 0;; ++i) {
            TRUSTED_INFO trusted;
            TCHAR key[32];
            ::wsprintf(key, TEXT("Trusted%d"), i);
            ::GetPrivateProfileString(APP_NAME, key, TEXT(""), trusted.path, _countof(trusted.path), iniPath);
            if (!trusted.path[0]) break;
            g_trusteds.push_back(trusted);
        }
    }

    if (g_fSetTime) {
        // SeSystemtimePrivilegeL
        g_fSetTime = false;
        HANDLE hToken;
        if (::OpenProcessToken(::GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) {
            LUID luid;
            if (::LookupPrivilegeValue(NULL, SE_SYSTEMTIME_NAME, &luid)) {
                TOKEN_PRIVILEGES tp;
                tp.PrivilegeCount = 1;
                tp.Privileges[0].Luid = luid;
                tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
                if (::AdjustTokenPrivileges(hToken, FALSE, &tp, 0, NULL, NULL) &&
                    ::GetLastError() == ERROR_SUCCESS)
                {
                    g_fSetTime = true;
                }
            }
            ::CloseHandle(hToken);
        }
        if (!g_fSetTime) {
            ::MessageBox(NULL, TEXT("VXe̎ύX錠܂B"), APP_NAME, MB_OK | MB_ICONWARNING);
        }
    }

    ::DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)DialogProc);
    return 0;
}
